
compression {

	;RLE unpacker
	asmsub decompress_rle(uword src @R0, uword dst @R1) clobbers(A,X,Y) {
		%asm {{

		src		=	$2; r0
		dst		=	$4; r1

next
        lda (src)
        beq done
        inc	src
        bne	+
        inc	src+1

    +   tax
        lda (src)
        inc	src
        bne	+
        inc	src+1

dofill
    ; +   nop ;simulate writing to Vera
    ;     nop
    ;     nop
    +	sta (dst)
        inc	dst
        bne	+
        inc	dst+1
        
    +	dex
        bne	dofill
        beq next

done
        rts
    
        }}
    }

	;LZ4 unpacker
	asmsub decompress_lz4(uword src @R0, uword dst @R1, uword end @R2 ) clobbers(A,X,Y) {
		%asm {{

		src		=	$2; r0
		dst		=	$4; r1
		end		=	$6; r2
		count	=	$8; r3
		delta	=	$a; r4
		copy 	= 	$c; r5

		unpack ;unpacker entrypoint

		parsetoken
				lda (src)
				inc	src
				bne	+
				inc	src+1
				
			+	pha
				lsr a
				lsr a
				lsr a
				lsr a
				beq	copymatches

				ldy	#1
				cmp	#$0f
				bne	_bc1
			-	sta	count

				lda (src)
				inc	src
				bne	+
				inc	src+1

			+	tax
				clc
				adc	count
				bcc	+
				iny
			+	inx
				beq	-

		_bc1	tax
		docopy1
				lda (src)
				inc	src
				bne	+
				inc	src+1

			+	sta (dst)
				inc	dst
				bne	+
				inc	dst+1	
				
			+	dex
				bne	docopy1
				dey
				bne	docopy1


				lda	src
				cmp	end
				lda	src+1
				sbc	end+1
				bcs	done

		copymatches
				lda (src)
				inc	src
				bne	+
				inc	src+1

			+	sta	delta

				lda (src)
				inc	src
				bne	+
				inc	src+1

			+	sta	delta+1
				pla
				and	#$0f

				ldy	#1
				cmp	#$0f
				bne	_bc2
			-	sta	count

				lda (src)
				inc	src
				bne	+
				inc	src+1

			+	tax
				clc
				adc	count
				bcc	+
				iny
			+	inx
				beq	-


		_bc2	clc
				adc	#4
				tax
				bcc	+
				iny

			+	sec
				lda	dst
				sbc	delta
				sta	copy
				lda	dst+1
				sbc	delta+1
				sta	copy+1

		docopy2
				lda (copy)
				inc	copy
				bne	+
				inc	copy+1

			+	sta (dst)
				inc	dst
				bne	+
				inc	dst+1	
				
			+	dex
				bne	docopy2
				dey
				bne	docopy2

				jmp	parsetoken

		done
				pla
				rts

		}}
    }

	;LZA1 unpacker
	asmsub decompress_lza1(uword src @R0, uword dst @R1) clobbers(A,X,Y) {
		%asm {{
	
lzsa_cmdbuf     =       $08                     ; 1 byte
lzsa_winptr     =       $06                     ; 1 word
lzsa_srcptr     =       $02                     ; 1 word
lzsa_dstptr     =       $04                     ; 1 word

lzsa_offset     =       lzsa_winptr

LZSA_SRC_LO     =       $09
LZSA_SRC_HI     =       $0A
LZSA_DST_LO     =       $0B
LZSA_DST_HI     =       $0C


; Args lzsa_srcptr = ptr to compessed data
; Args lzsa_dstptr = ptr to output buffer
;

DECOMPRESS_LZSA1_FAST
lzsa1_unpack   	ldy     #0                      ; Initialize source index
            	ldx     #0                      ; Initialize hi-byte of length

;
; Copy bytes from compressed source data
;
; NB X=0 is expected and guaranteed when we get here
;

cp_length     
                lda     (lzsa_srcptr),y
                inc     <lzsa_srcptr + 0
                bne     cp_skip0
                inc     <lzsa_srcptr + 1

cp_skip0      	sta     <lzsa_cmdbuf            ; Preserve this for later
                and     #$70                    ; Extract literal length
                lsr a                            ; Set CC before 
                beq     lz_offset              ; Skip directly to match?

                lsr a                            ; Get 3-bit literal length
                lsr a
                lsr a
                cmp     #$07                    ; Extended length?
                bcc     cp_got_len

                jsr     get_length             ; X=0, CS from CMP, returns CC
                stx     cp_npages + 1          ; Hi-byte of length

cp_got_len    	tax                             ; Lo-byte of length

cp_byte       	lda     (lzsa_srcptr),y         ; CC throughout the execution of
                sta     (lzsa_dstptr),y         ; of this cp_page loop
                inc     <lzsa_srcptr + 0
                bne     cp_skip1
                inc     <lzsa_srcptr + 1
cp_skip1      	inc     <lzsa_dstptr + 0
                bne     cp_skip2
                inc     <lzsa_dstptr + 1
cp_skip2      	dex
                bne     cp_byte
cp_npages     	lda     #0                      ; Any full pages left to copy?
                beq     lz_offset

                dec     cp_npages + 1          ; Unlikely, so can be slow
                bcc     cp_byte                ; Always true!

;
; Copy bytes from decompressed window
;
; Longer but faster
;
; NB X=0 is expected and guaranteed when we get here
;

lz_offset     	lda     (lzsa_srcptr),y         ; Get offset-lo
                inc     <lzsa_srcptr + 0
                bne     offset_lo
                inc     <lzsa_srcptr + 1

offset_lo     	sta     <lzsa_offset + 0

                lda     #$FF                    ; Get offset-hi
                bit     <lzsa_cmdbuf
                bpl     offset_hi

                lda     (lzsa_srcptr),y
                inc     <lzsa_srcptr + 0
                bne     offset_hi
                inc     <lzsa_srcptr + 1

offset_hi     	sta     <lzsa_offset + 1

lz_length     	lda     <lzsa_cmdbuf            ; X=0 from previous loop
                and     #$0F
                adc     #$03                    ; Always CC from cp_page loop
                cmp     #$12                    ; Extended length?
                bcc     got_lz_len

                jsr     get_length             ; X=0, CS from CMP, returns CC

got_lz_len    	inx                             ; Hi-byte of length+256

                eor     #$FF                    ; Negate the lo-byte of length
                tay
                eor     #$FF

get_lz_dst    	adc     <lzsa_dstptr + 0        ; Calc address of partial page
                sta     <lzsa_dstptr + 0        ; Always CC from previous CMP
                iny
                bcs     get_lz_win
                beq     get_lz_win             ; Is lo-byte of length zero?
                dec     <lzsa_dstptr + 1

get_lz_win    	clc                             ; Calc address of match
                adc     <lzsa_offset + 0        ; NB Offset is negative!
                sta     <lzsa_winptr + 0
                lda     <lzsa_dstptr + 1
                adc     <lzsa_offset + 1
                sta     <lzsa_winptr + 1

lz_byte       	lda     (lzsa_winptr),y
                sta     (lzsa_dstptr),y
                iny
                bne     lz_byte
                inc     <lzsa_dstptr + 1
                dex                             ; Any full pages left to copy?
                bne     lz_more

                jmp     cp_length              ; Loop around to the beginning

lz_more       	inc     <lzsa_winptr + 1        ; Unlikely, so can be slow
                bne     lz_byte                ; Always true!

;
; Get 16-bit length in XA register pair, return with CC
;
; NB X=0 is expected and guaranteed when we get here
;

get_length    	clc                             ; Add on the next byte to get
                adc     (lzsa_srcptr),y         ; the length
                inc     <lzsa_srcptr + 0
                bne     skip_inc
                inc     <lzsa_srcptr + 1

skip_inc     	bcc     got_length             ; No overflow means done
                clc                             ; MUST return CC!
                tax                             ; Preserve overflow value

extra_byte    	jsr     get_byte               ; So rare, this can be slow!
                pha
                txa                             ; Overflow to 256 or 257?
                beq     extra_word

check_length  	pla                             ; Length-lo
                bne     got_length             ; Check for zero
                dex                             ; Do one less page loop if so
got_length    	rts

extra_word    	jsr     get_byte               ; So rare, this can be slow!
                tax
                bne     check_length           ; Length-hi == 0 at EOF

finished      	pla                             ; Length-lo
                pla                             ; Decompression completed, pop
                pla                             ; return address
                rts

get_byte      	lda     (lzsa_srcptr),y         ; Subroutine version for when
                inc     <lzsa_srcptr + 0        ; inlining isn't advantageous
                bne     got_byte
                inc     <lzsa_srcptr + 1        ; Inc & test for bank overflow
got_byte      	rts	
	
		}}
	}

	;Salvador unpacker (ZX0)
	asmsub decompress_salvador(uword src @R0, uword dst @R1) clobbers(A,X,Y) {
		%asm {{

zx0_srcptr      =       $02                     ; 1 word.
zx0_dstptr      =       $04                     ; 1 word.
zx0_length      =       $06                     ; 1 word.
zx0_offset      =       $08                     ; 1 word.

; ***************************************************************************
; ***************************************************************************
;
; zx0_unpack - Decompress data stored in Einar Saukas's ZX0 format.
;
; Args zx0_srcptr = ptr to compessed data
; Args zx0_dstptr = ptr to output buffer
; Uses lots!
;

zx0_unpack     ldy     #$FF                    ; Initialize default offset.
                sty     <zx0_offset+0
                sty     <zx0_offset+1
                iny                             ; Initialize source index.
                sty     <zx0_length+1           ; Initialize length to 1.

                ldx     #$40                    ; Initialize empty buffer.

zx0_next_cmd   lda     #1                      ; Initialize length back to 1.
                sta     <zx0_length + 0

                txa                             ; Restore bit-buffer.

                asl a                             ; Copy from literals or new offset?
                bcc     zx0_cp_literal

                ;
                ; Copy bytes from new offset.
                ;

zx0_new_offset jsr     zx0_gamma_flag          ; Get offset MSB, returns CS.

                tya                             ; Negate offset MSB and check
                sbc     <zx0_length + 0         ; for zero (EOF marker).
                bcs     zx0_got_eof

                sec
                ror a
                sta     <zx0_offset + 1         ; Save offset MSB.

                lda     (<zx0_srcptr),y         ; Get offset LSB.
                inc     <zx0_srcptr + 0
                beq     zx0_inc_of_src

zx0_off_skip1  ror a                             ; Last offset bit starts gamma.
                sta     <zx0_offset + 0         ; Save offset LSB.

                lda     #-2                     ; Minimum length of 2?
                bcs     zx0_get_lz_dst

                lda     #1                      ; Initialize length back to 1.
                sta     <zx0_length + 0

                txa                             ; Restore bit-buffer.

                jsr     zx0_gamma_data          ; Get length, returns CS.

                lda     <zx0_length + 0         ; Negate lo-byte of (length+1).
                eor     #$FF

zx0_get_lz_dst tay                             ; Calc address of partial page.
                eor     #$FF                    ; Always CS from previous SBC.
                adc     <zx0_dstptr + 0
                sta     <zx0_dstptr + 0
                bcs     zx0_get_lz_win

                dec     <zx0_dstptr + 1

zx0_get_lz_win clc                             ; Calc address of match.
                adc     <zx0_offset + 0         ; N.B. Offset is negative!
                sta     zx0_winptr + 0
                lda     <zx0_dstptr + 1
                adc     <zx0_offset + 1
                sta     zx0_winptr + 1

zx0_winptr      =       *+1

zx0_lz_page    lda     $1234,y                 ; Self-modifying zx0_winptr.
                sta     (<zx0_dstptr),y
                iny
                bne     zx0_lz_page
                inc     <zx0_dstptr + 1

                lda     <zx0_length + 1         ; Any full pages left to copy?
                beq     zx0_next_cmd

                dec     <zx0_length + 1         ; This is rare, so slower.
                inc     zx0_winptr + 1
                bne     zx0_lz_page             ; Always true.

zx0_got_eof    rts                             ; Finished decompression.

                ;
                ; Copy bytes from compressed source.
                ;

zx0_cp_literal jsr     zx0_gamma_flag          ; Get length, returns CS.

                pha                             ; Preserve bit-buffer.

                ldx     <zx0_length + 0         ; Check the lo-byte of length
                bne     zx0_cp_byte             ; without effecting CS.

zx0_cp_page    dec     <zx0_length + 1         ; Decrement # of pages to copy.

zx0_cp_byte    lda     (<zx0_srcptr),y         ; CS throughout the execution of
                sta     (<zx0_dstptr),y         ; of this .cp_page loop.

                inc     <zx0_srcptr + 0
                beq     zx0_inc_cp_src

zx0_cp_skip1   inc     <zx0_dstptr + 0
                beq     zx0_inc_cp_dst

zx0_cp_skip2   dex                             ; Any bytes left to copy?
                bne     zx0_cp_byte

                lda     <zx0_length + 1         ; Any full pages left to copy?
                bne     zx0_cp_page             ; Optimized for branch-unlikely.

                inx                             ; Initialize length back to 1.
                stx     <zx0_length + 0

                pla                             ; Restore bit-buffer.

                asl a                            ; Copy from last offset or new offset?
                bcs     zx0_new_offset

                ;
                ; Copy bytes from last offset (rare so slower).
                ;

zx0_old_offset jsr     zx0_gamma_flag          ; Get length, returns CS.

                tya                             ; Negate the lo-byte of length.
                sbc     <zx0_length + 0
                sec                             ; Ensure CS before zx0_get_lz_dst!
                bne     zx0_get_lz_dst

                dec     <zx0_length + 1         ; Decrement because lo-byte=0.
                bcs     zx0_get_lz_dst          ; Always true!

                ;
                ; Optimized handling of pointers crossing page-boundaries.
                ;

zx0_inc_of_src inc     <zx0_srcptr + 1
                bne     zx0_off_skip1           ; Always true.

zx0_inc_cp_src inc     <zx0_srcptr + 1
                bcs     zx0_cp_skip1            ; Always true.

zx0_inc_cp_dst inc     <zx0_dstptr + 1
                bcs     zx0_cp_skip2            ; Always true.

zx0_inc_ga_src inc     <zx0_srcptr + 1
                bne     zx0_gamma_skip          ; Always true.

                ;
                ; Get 16-bit interlaced Elias gamma value.
                ;

zx0_gamma_data asl a                             ; Get next bit.
                rol     <zx0_length + 0
zx0_gamma_flag asl a
                bcc     zx0_gamma_data          ; Loop until finished or empty.
                bne     zx0_gamma_done          ; Bit-buffer empty?

zx0_gamma_load lda     (<zx0_srcptr),y         ; Reload the empty bit-buffer
                inc     <zx0_srcptr + 0         ; from the compressed source.
                beq     zx0_inc_ga_src
zx0_gamma_skip rol a
                bcs     zx0_gamma_done          ; Finished?

zx0_gamma_word asl a                            ; Get next bit.
                rol     <zx0_length + 0
                rol     <zx0_length + 1
                asl a
                bcc     zx0_gamma_word          ; Loop until finished or empty.
                beq     zx0_gamma_load          ; Bit-buffer empty?

zx0_gamma_done tax                             ; Preserve bit-buffer.
                rts




		}}
	}
}