%import diskio
%import compression

%zeropage basicsafe
%option no_sysinit

main {

    sub start() {

		uword loadend

		txt.clear_screen()

		load_file("image.bin")
		txt.nl()

		load_file("image.lza")
		cbm.SETTIM(0,0,0)
		cx16.memory_decompress($1000,$4000)
		stats()

		load_file("image.lz1")
		cbm.SETTIM(0,0,0)
		compression.decompress_lza1($1000,$4000)
		stats()

		loadend = load_file("image.lz4")
		cbm.SETTIM(0,0,0)
		compression.decompress_lz4($100B, $4000, loadend);skip header
		stats()

		load_file("image.rle")
		cbm.SETTIM(0,0,0)
		compression.decompress_rle($1000, $4000)
		stats()

		load_file("image.sal")
		cbm.SETTIM(0,0,0)
		compression.decompress_salvador($1000, $4000)
		stats()

    }

	sub load_file(uword file) -> uword {

		uword loadend
		uword crc

		cx16.memory_fill($1000,$8000,0)

		txt.print(file)
		txt.nl()
		cbm.SETTIM(0,0,0)
        loadend = diskio.load_raw(file,$1000)
		txt.print("load: ")
		txt.print_uw(cbm.RDTIM16())
		txt.nl()
		txt.print("size: ")
		txt.print_uw(loadend-$1000)
		txt.nl()
		crc = cx16.memory_crc($1000,loadend-$1000)
		txt.print("crc: ")
		txt.print_uw(crc)
		txt.nl()

		return loadend
	}
	sub stats()
	{
		uword crc
		uword expected = 160*120

		txt.print("unpack: ")
        txt.print_uw(cbm.RDTIM16())
		txt.nl()
		crc = cx16.memory_crc($4000,expected)
		txt.print("check: ")
		txt.print_uw(crc)
		txt.nl()
		txt.nl()		
	}

}